﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TestView.Ensaios;

namespace ModuloEnsaioTracao
{
    public class ModuloEnsaioTracao : IModuloDeEnsaio
    {

        #region Construtor e membros

        private IModuloGUI _moduloGui;
        private IRotinaDeEnsaio _rotinaDeEnsaio;

        public ModuloEnsaioTracao()
        {
            RotinaDeEnsaioTracao rotinaDeEnsaio = new RotinaDeEnsaioTracao();
            ModuloTracaoGUI moduloGUI = new ModuloTracaoGUI();
            rotinaDeEnsaio.ModuloTracaoGUI = moduloGUI;
            moduloGUI.RotinaDeEnsaio = rotinaDeEnsaio;
            this._moduloGui = moduloGUI;
            this._rotinaDeEnsaio = rotinaDeEnsaio;
        }

        public IRotinaDeEnsaio RotinaDeEnsaio
        {
            get
            {
                return this._rotinaDeEnsaio;
            }
        }

        public IModuloGUI FachadaGUI
        {
            get 
            {
                return this._moduloGui;
            }
        }

        #endregion
    }
}
