﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace TestView.Condicionador.ItemCalibracao
{
    [DataContract]
    public class PontoDeCalibracao : IComparable
    {
        [DataMember(Name="Ponto")]
        private long _ponto;
        private double _valor;

        public long Ponto 
        { 
            get 
            {
                return this._ponto;
            }
        }

        [DataMember]
        public double Valor 
        {
            get
            {
                return this._valor;
            }
            set
            {
                this._valor = value;
            }
        }

        public PontoDeCalibracao(long ponto, double valor)
        {
            this._ponto = ponto;
            this._valor = valor;
        }

        public PontoDeCalibracao() { }

        public int CompareTo(object obj)
        {
            PontoDeCalibracao ponto = (PontoDeCalibracao)obj;
            if (this.Ponto == ponto.Ponto)
            {
                return 0;
            }
            else if (this.Ponto > ponto.Ponto)
            {
                return 1;
            }
            else 
            {
                return -1;
            }
        }
    }
}
