﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TestView.Ensaios;

namespace TestView.Dados.Modelo
{
    public class ModuloEnsaioDTO
    {
        private int _id;
        private String _nomeModulo;
        private String _versao;

        public int Id
        {
            get
            {
                return this._id;
            }
            set
            {
                this._id = value;
            }
        }
        public String NomeModulo
        {
            get
            {
                return this._nomeModulo;
            }
            set
            {
                this._nomeModulo = value;
            }
        }
        public String Versao
        {
            get
            {
                return this._versao;
            }
            set
            {
                this._versao = value;
            }
        }

        public ModuloEnsaioDTO() { }
        public ModuloEnsaioDTO(int id, string nome, string versao)
        {
            this.Id = id;
            this.NomeModulo = nome;
            this.Versao = versao;
        }
        public ModuloEnsaioDTO(IModuloDeEnsaio modulo)
        {
            this.Id = modulo.Id;
            this.NomeModulo = modulo.NomeModulo;
            this.Versao = modulo.Versao;
        }
    }
}
