﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TestView.Excecoes
{
    public class TestViewException : ApplicationException
    {
        public TestViewException() { }
        public TestViewException(string message) : base(message) { }
        public TestViewException(string message, Exception innerEx) : base(message, innerEx) { }
    }

    public class PortaSerialDesconectadaException : TestViewException
    {
        public PortaSerialDesconectadaException() { }
        public PortaSerialDesconectadaException(string message) : base(message) { }
        public PortaSerialDesconectadaException(string message, Exception innerEx) : base(message, innerEx) { }
    }

    public class EnsaioNaoCarregadoException : TestViewException
    {
        public EnsaioNaoCarregadoException() { }
        public EnsaioNaoCarregadoException(string message) : base(message) { }
        public EnsaioNaoCarregadoException(string message, Exception innerEx) : base(message, innerEx) { }
    }

    public class ArquivoDeCalibracaoNaoEncontradoException : TestViewException
    {
        public ArquivoDeCalibracaoNaoEncontradoException() { }
        public ArquivoDeCalibracaoNaoEncontradoException(string message) : base(message) { }
        public ArquivoDeCalibracaoNaoEncontradoException(string message, Exception innerEx) : base(message, innerEx) { }
    }
}
