﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using TestView;
using TestView.Conexoes;
using System.IO;
using System.Windows.Markup;

namespace TestViewGUIWPF.Conexoes
{
    /// <summary>
    /// Interaction logic for JanelaConexoes.xaml
    /// </summary>
    public partial class JanelaConexoes : Window
    {
        #region Construtor e membros

        private int _indice;
        private List<GroupBox> _listGroupBoxConexoes;
        
        public JanelaConexoes()
        {
            _indice = 0;
            _listGroupBoxConexoes = new List<GroupBox>();
            InitializeComponent();
        }

        #endregion

        #region Layout

        //private GroupBox criaNovoGroupBoxConexao(String nomePorta, String nomeCondidionador, int baudRate)
        //{
        //    GroupBox groupBox = new GroupBox {
        //        Name = "groupBoxConexao" + _indice.ToString(),
        //        Header = "Conexão " + (_listGroupBoxConexoes.Count + 1).ToString(),
        //    };

        //    // Definindo grid
        //    RowDefinition linha1 = new RowDefinition();
        //    RowDefinition linha2 = new RowDefinition();
        //    ColumnDefinition coluna1 = new ColumnDefinition();
        //    ColumnDefinition coluna2 = new ColumnDefinition();
        //    ColumnDefinition coluna3 = new ColumnDefinition();
        //    Grid gridGroupboxContent = new Grid();
        //    gridGroupboxContent.RowDefinitions.Add(linha1);
        //    gridGroupboxContent.RowDefinitions.Add(linha2);
        //    gridGroupboxContent.ColumnDefinitions.Add(coluna1);
        //    gridGroupboxContent.ColumnDefinitions.Add(coluna2);
        //    gridGroupboxContent.ColumnDefinitions.Add(coluna3);

        //    // Imagem do conector serial
        //    BitmapImage imagemBitmapSerial = new BitmapImage(new Uri(@"pack://application:,,,/TestViewGUIWPF;component/Imagens/serial.gif"));
        //    Image imagemSerial = new Image
        //    {
        //        Source = imagemBitmapSerial,
        //        Width = 42,
        //        Height = 42
        //    };
        //    Grid.SetColumn(imagemSerial, 0);
        //    Grid.SetRow(imagemSerial, 0);
        //    Grid.SetRowSpan(imagemSerial, 2);
        //    gridGroupboxContent.Children.Add(imagemSerial);

        //    // Texto porta serial
        //    TextBlock textoPortaSerial = new TextBlock
        //    {
        //        Text = Properties.Resources.portaSerialString
        //    };
        //    Grid.SetColumn(textoPortaSerial, 1);
        //    Grid.SetRow(textoPortaSerial, 0);
        //    gridGroupboxContent.Children.Add(textoPortaSerial);

        //    // Combobox porta serial
        //    ComboBox comboboxPortaSerial = new ComboBox();
        //    Grid.SetColumn(comboboxPortaSerial, 1);
        //    Grid.SetRow(comboboxPortaSerial, 1);
        //    gridGroupboxContent.Children.Add(comboboxPortaSerial);

        //    // Texto Condicionador de sinal
        //    TextBlock textoCondicionardor = new TextBlock
        //    {
        //        Text = Properties.Resources.condicionadorSinalString
        //    };
        //    Grid.SetColumn(textoCondicionardor, 2);
        //    Grid.SetRow(textoCondicionardor, 0);
        //    gridGroupboxContent.Children.Add(textoCondicionardor);

        //    groupBox.Content = gridGroupboxContent; 
        //    //PictureBox pictureBoxSerial = new PictureBox();
        //    //pictureBoxSerial.Image = Properties.Resources.serial;
        //    //pictureBoxSerial.Size = Properties.Resources.serial.Size;
        //    //pictureBoxSerial.Location = new Point(3, 15);

        //    //Label labelPorta = new Label();
        //    //labelPorta.Name = "labelPortaSerial" + _indice.ToString();
        //    //labelPorta.Text = "Porta Serial:";
        //    //labelPorta.AutoSize = true;
        //    //labelPorta.Location = new Point(50, 16);

        //    //ComboBox comboBoxPorta = new ComboBox();
        //    //comboBoxPorta.Name = "comboBoxPorta" + _indice.ToString();
        //    //comboBoxPorta.Location = new Point(53, 32);
        //    //comboBoxPorta.Size = new Size(59, 21);
        //    //comboBoxPorta.DropDownStyle = ComboBoxStyle.DropDownList;
        //    //comboBoxPorta.Items.AddRange(PortaSerial.listaPortasSeriais());
        //    //if (comboBoxPorta.Items.Count > 0)
        //    //{
        //    //    if (nomePorta != null && comboBoxPorta.Items.Contains(nomePorta))
        //    //    {
        //    //        comboBoxPorta.SelectedItem = nomePorta;
        //    //    }
        //    //    else
        //    //    {
        //    //        comboBoxPorta.SelectedIndex = 0;
        //    //    }
        //    //}

        //    //Label labelCondicionador = new Label();
        //    //labelCondicionador.Name = "labelCondicionadorSinal" + _indice.ToString();
        //    //labelCondicionador.Text = "Condicionador de sinal:";
        //    //labelCondicionador.AutoSize = true;
        //    //labelCondicionador.Location = new Point(115, 16);

        //    //ComboBox comboBoxCondicionador = new ComboBox();
        //    //comboBoxCondicionador.Name = "comboBoxCondicionador" + _indice.ToString();
        //    //comboBoxCondicionador.Location = new Point(118, 32);
        //    //comboBoxCondicionador.Size = new Size(114, 21);
        //    //comboBoxCondicionador.DropDownStyle = ComboBoxStyle.DropDownList;
        //    //foreach (KeyValuePair<int, String> item in CondicionadorSinal.dicionarioCondicionadores())
        //    //{
        //    //    int idx = comboBoxCondicionador.Items.Add(item.Value);
        //    //}
        //    //if (comboBoxCondicionador.Items.Count > 0)
        //    //{
        //    //    if (nomeCondidionador != null && comboBoxCondicionador.Items.Contains(nomeCondidionador))
        //    //    {
        //    //        comboBoxCondicionador.SelectedItem = nomeCondidionador;
        //    //    }
        //    //    else
        //    //    {
        //    //        comboBoxCondicionador.SelectedIndex = 0;
        //    //    }
        //    //}

        //    //Label labelBaudrate = new Label();
        //    //labelBaudrate.Name = "labelBaudrate" + _indice.ToString();
        //    //labelBaudrate.Text = "Baud rate:";
        //    //labelBaudrate.AutoSize = true;
        //    //labelBaudrate.Location = new Point(235, 16);

        //    //ComboBox comboBoxBaudrate = new ComboBox();
        //    //comboBoxBaudrate.Name = "comboBoxBaudrate" + _indice.ToString();
        //    //comboBoxBaudrate.Location = new Point(238, 32);
        //    //comboBoxBaudrate.Size = new Size(60, 21);
        //    //comboBoxBaudrate.DropDownStyle = ComboBoxStyle.DropDownList;
        //    //for (int i=0; i < PortaSerial.listaBaudRates().Length; i++)
        //    //{
        //    //    comboBoxBaudrate.Items.Add(PortaSerial.listaBaudRates()[i]);
        //    //}
            
        //    //if (comboBoxBaudrate.Items.Count > 0)
        //    //{
        //    //    if (comboBoxBaudrate.Items.Contains(baudRate))
        //    //    {
        //    //        comboBoxBaudrate.SelectedItem = baudRate;
        //    //    }
        //    //    else
        //    //    {
        //    //        comboBoxBaudrate.SelectedItem = PortaSerial.BaudRatePadrao;
        //    //    }
        //    //}

        //    //Button buttonRemover = new Button();
        //    //buttonRemover.Anchor = AnchorStyles.Top | AnchorStyles.Right;
        //    //buttonRemover.Name = "buttonRemover" + _indice.ToString();
        //    //buttonRemover.Text = "Remover";
        //    //buttonRemover.Location = new Point(groupBox.Size.Width - 81, 30);
        //    //buttonRemover.Size = new Size(75, 23);
        //    //buttonRemover.Click += new System.EventHandler(this.buttonRemover_Click);

        //    //groupBox.Controls.Add(pictureBoxSerial);
        //    //groupBox.Controls.Add(labelPorta);
        //    //groupBox.Controls.Add(labelCondicionador);
        //    //groupBox.Controls.Add(comboBoxPorta);
        //    //groupBox.Controls.Add(comboBoxCondicionador);
        //    //groupBox.Controls.Add(labelBaudrate);
        //    //groupBox.Controls.Add(comboBoxBaudrate);
        //    //groupBox.Controls.Add(buttonRemover);
        //    return groupBox;
        //}

        //private void insereGroupBoxConexao(GroupBox groupBoxConexao)
        //{
        //    DockPanel.SetDock(groupBoxConexao, Dock.Top);
        //    dockPanelConexoes.Children.Add(groupBoxConexao);
        //}

        //private void adicionaNovaGroupBoxConexao(String nomePorta, String modeloCondicionadorSinal, int baudRate)
        //{
        //    GroupBox groupBox = criaNovoGroupBoxConexao(nomePorta, modeloCondicionadorSinal, baudRate);
        //    _listGroupBoxConexoes.Add(groupBox);
        //    insereGroupBoxConexao(groupBox);
        //    _indice++;
        //}

        //private void removeGroupBoxConexao(GroupBox groupBoxConexaoRemover)
        //{
        //    for (int i = _listGroupBoxConexoes.Count - 1; i >= 0; i--)
        //    {
        //        dockPanelConexoes.Children.Remove(_listGroupBoxConexoes.ElementAt(i));
        //        //this.Size = new Size(this.Size.Width, this.Size.Height - 68);
        //    }
        //    _listGroupBoxConexoes.Remove(groupBoxConexaoRemover);
        //    //for (int i = 0; i < _listGroupBoxConexoes.Count; i++)
        //    //{
        //    //    GroupBox groupBoxConexaoExistente = _listGroupBoxConexoes.ElementAt(i);
        //    //    groupBoxConexaoExistente.Location = new Point(12, 41 + i * 68);
        //    //    groupBoxConexaoExistente.Text = String.Format("{0} {1}", Properties.Resources.conexaoString, i + 1);
        //    //    insereGroupBoxConexao(groupBoxConexaoExistente);
        //    //}
        //}

        #endregion

        #region Conexao

        //private void salvarConexoes()
        //{
        //    GerenciadorEnsaios.getInstance().removeTodasConexoes();
        //    foreach (GroupBox groupBoxConexao in _listGroupBoxConexoes)
        //    {
        //        String nomePorta = null;
        //        int modeloCondicionadorSinal = int.MaxValue;
        //        int baudRate = int.MaxValue;
        //        foreach (Control control in groupBoxConexao.Controls)
        //        {
        //            if (control.Name.StartsWith("comboBoxPorta"))
        //            {
        //                ComboBox comboBoxPorta = (ComboBox)control;
        //                nomePorta = comboBoxPorta.SelectedItem.ToString();
        //            }
        //            else if (control.Name.StartsWith("comboBoxCondicionador"))
        //            {
        //                ComboBox comboBoxCondicionador = (ComboBox)control;
        //                modeloCondicionadorSinal = comboBoxCondicionador.SelectedIndex;
        //            }
        //            else if (control.Name.StartsWith("comboBoxBaudrate"))
        //            {
        //                ComboBox comboBoxBaudrate = (ComboBox)control;
        //                baudRate = (int)comboBoxBaudrate.SelectedItem;
        //            }
        //        }
        //        if (nomePorta != null && modeloCondicionadorSinal != int.MaxValue && baudRate != int.MaxValue)
        //        {
        //            GerenciadorEnsaios.getInstance().adicionaNovaConexao(nomePorta, modeloCondicionadorSinal, baudRate);
        //        }
        //    }
        //}

        #endregion

        #region Eventos do form

        //private void buttonRemover_Click(object sender, EventArgs e)
        //{
        //    Button buttonRemover = (Button)sender;
        //    GroupBox groupBoxConexaoRemover = (GroupBox)buttonRemover.Parent;
        //    removeGroupBoxConexao(groupBoxConexaoRemover);
        //}

        //private void buttonCancelar_Click(object sender, EventArgs e)
        //{
        //    this.Close();
        //}

        //private void Window_Loaded(object sender, RoutedEventArgs e)
        //{
        //    //foreach (Conexao conexao in GerenciadorEnsaios.getInstance().listaConexoes())
        //    //{
        //    //    adicionaNovaGroupBoxConexao(conexao.PortaSerial.NomePorta, conexao.CondicionadorSinal.Modelo, conexao.PortaSerial.BaudRate);
        //    //}
        //}

        //private void botaoAdicionar_Click(object sender, RoutedEventArgs e)
        //{
        //    adicionaNovaGroupBoxConexao(null, null, int.MaxValue);
        //}

        //private void botaoAplicar_Click(object sender, RoutedEventArgs e)
        //{
        //    using (Stream stream = File.OpenWrite(@"C:\Users\Rodolfo\Desktop\Test.xaml"))
        //    {
        //        XamlWriter.Save(this, stream);
        //    }
        //}

        //private void buttonOk_Click(object sender, EventArgs e)
        //{
        //    salvarConexoes();
        //    this.Close();
        //}

        //private void buttonAplicar_Click(object sender, EventArgs e)
        //{
        //    salvarConexoes();
        //}

        #endregion
    }
}
