﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Printing;

namespace TesteWinForm
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Graphics g = this.panel1.CreateGraphics();
            this.geraPagina(g);
            PrintPreviewDialog preview = new PrintPreviewDialog();
            PrintDocument document = new PrintDocument();
            document.PrintPage += new PrintPageEventHandler(document_PrintPage);
            preview.Document = document;
            preview.ShowDialog();
            //document.Print();

        }

        private void document_PrintPage(object sender, PrintPageEventArgs e)
        {
            this.geraPagina(e.Graphics);
        }

        private void geraPagina(Graphics g)
        {
            float fator = g.VisibleClipBounds.Size.Width / g.DpiX;
            Font f = new System.Drawing.Font(FontFamily.GenericSansSerif, 5f * fator);
            float altura = f.GetHeight(g);
            Brush b = new SolidBrush(Color.Black);
            g.DrawString(String.Format("{0}, {1} dpi", g.DpiX, g.DpiY), f, b, 0, 0);
            g.DrawString(String.Format("{0}", g.PageUnit.ToString()), f, b, 0, altura);
            g.DrawString(String.Format("{0}, {1}, width, height", g.VisibleClipBounds.Size.Width, g.VisibleClipBounds.Size.Height), f, b, 0, 2 * altura);
        }
    }
}
