﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;

namespace AdEmulator
{
    public partial class FormEmulador : Form
    {
        public delegate void Delegacao(String s);

        public FormEmulador()
        {
            InitializeComponent();
        }

        private void FormEmulador_Load(object sender, EventArgs e)
        {
            comboBoxPorta.Items.Clear();
            comboBoxPorta.Items.AddRange(SerialPort.GetPortNames());
            //Emulador.getInstance().ComandosChanged += new EventHandler(FormEmulador_ComandosChanged);
        }

        //private void setText(String text)
        //{
        //    if (this.textBoxRecepcao.InvokeRequired) {
        //        Delegacao d = new Delegacao(setText);
        //        this.Invoke(d, new object[] {text});
        //    }
        //    else {
        //        this.textBoxRecepcao.Text += text;
        //    }
        //}

        //void FormEmulador_ComandosChanged(object sender, EventArgs e)
        //{
        //    List<String> comandos = Emulador.getInstance().readComandos();
        //    String texto = "";
        //    foreach (String c in comandos)
        //    {
        //        texto += c + "\r\n";
        //    }
        //    setText(texto);
        //}

        private void buttonConectar_Click(object sender, EventArgs e)
        {
            if (!Emulador.getInstance().estaConectado())
            {
                Emulador.getInstance().conectar(comboBoxPorta.SelectedItem.ToString(), 38400, Parity.Even);
            }
        }

        private void buttonDesconectar_Click(object sender, EventArgs e)
        {
            Emulador.getInstance().desconectar();
        }

        private void checkBoxAutomatico_CheckedChanged(object sender, EventArgs e)
        {
            Emulador.getInstance().Automatico = this.checkBoxAutomatico.Checked;
            Emulador.getInstance().horaInicial = DateTime.Now.TimeOfDay.TotalMilliseconds;
        }

        private void trackBarPontos_Scroll(object sender, EventArgs e)
        {
            Emulador.getInstance().Pontos = this.trackBarPontos.Value;
        }

        private void radioButtonSenoidal_CheckedChanged(object sender, EventArgs e)
        {
            Emulador.getInstance().curvaAutomatica = "SENOIDAL";
        }

        private void radioButtonLinear_CheckedChanged(object sender, EventArgs e)
        {
            Emulador.getInstance().curvaAutomatica = "LINEAR";
        }
    }
}
