﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TestView.Ensaios;
using TestView.Ensaios.Utilidades.CorposDeProva;

namespace ModuloEnsaioElasticidade
{
    class EnsaioElasticidade : IEnsaio
    {
        private DateTime _dataEnsaio;
        private ICorpoDeProva _corpoProva;

        public EnsaioElasticidade()
        {
            this._dataEnsaio = DateTime.Now;
        }

        public DateTime DataEnsaio
        {
            get
            {
                return this._dataEnsaio;
            }
        }

        public ICorpoDeProva CorpoDeProva
        {
            get
            {
                return this._corpoProva;
            }
            set
            {
                this._corpoProva = value;
            }
        }
    }
}
