﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace ModuloEnsaioTracao.Ensaios
{
    [DataContract]
    public class OpcaoModuloElasticidadeTempoReal : ICloneable
    {
        #region Construtor e membros

        private double _pontoInicial;
        private double _pontoFinal;

        [DataMember]
        public Double PontoInicial
        {
            get
            {
                return this._pontoInicial;
            }
            set
            {
                this._pontoInicial = value;
            }
        }
        [DataMember]
        public Double PontoFinal
        {
            get
            {
                return this._pontoFinal;
            }
            set
            {
                this._pontoFinal = value;
            }
        }

        public OpcaoModuloElasticidadeTempoReal()
        {
            this.PontoInicial = 0.2;
            this.PontoFinal = 0.4;
        }

        #endregion

        #region Misc.

        public object Clone()
        {
            OpcaoModuloElasticidadeTempoReal opcao = new OpcaoModuloElasticidadeTempoReal();
            opcao.PontoInicial = this.PontoInicial;
            opcao.PontoFinal = this.PontoFinal;
            return opcao;
        }

        #endregion
    }
}
