﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace TestView.Ensaios.Utilidades
{
    [DataContract]
    public class InformacaoAdicional : ICloneable
    {
        #region Construtor e membros

        private string _informacao;
        private string _valor;

        [DataMember]
        public string Informacao
        {
            get
            {
                return this._informacao;
            }
            set
            {
                this._informacao = value;
            }
        }

        [DataMember]
        public string Valor
        {
            get
            {
                return this._valor;
            }
            set
            {
                this._valor = value;
            }
        }

        public InformacaoAdicional(string informacao, string valor)
        {
            this._informacao = informacao;
            this._valor = valor;
        }

        #endregion

        #region Misc.

        public object Clone()
        {
            InformacaoAdicional info = new InformacaoAdicional(this.Informacao, this.Valor);
            return info;
        }

        public override string ToString()
        {
            return this.Informacao;
        }

        #endregion
    }
}
