﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Ionic.Zip;

namespace TestView.Relatorios
{
    public abstract class ArquivoOpenDocument
    {
        public abstract Dictionary<String, byte[]> Items
        {
            get;
        }

        public void salvarRelatorio(string nomeArquivo)
        {
            ZipFile arquivoOpenDocument = new ZipFile();
            foreach (KeyValuePair<String, byte[]> item in this.Items)
            {
                String nomeItem = item.Key;
                byte[] conteudoItem = item.Value;
                arquivoOpenDocument.AddEntry(nomeItem, conteudoItem);
            }
            arquivoOpenDocument.Save(nomeArquivo);
        }
    }
}
